"use strict";

require("core-js/modules/es.symbol");

require("core-js/modules/es.symbol.description");

require("core-js/modules/es.symbol.iterator");

require("core-js/modules/es.array.concat");

require("core-js/modules/es.array.from");

require("core-js/modules/es.array.is-array");

require("core-js/modules/es.array.iterator");

require("core-js/modules/es.array.slice");

require("core-js/modules/es.date.to-string");

require("core-js/modules/es.function.name");

require("core-js/modules/es.object.define-property");

require("core-js/modules/es.object.to-string");

require("core-js/modules/es.promise");

require("core-js/modules/es.regexp.exec");

require("core-js/modules/es.regexp.to-string");

require("core-js/modules/es.string.iterator");

require("core-js/modules/es.string.replace");

require("core-js/modules/web.dom-collections.iterator");

require("regenerator-runtime/runtime");

var _inquirer = _interopRequireDefault(require("inquirer"));

var _promisifyChildProcess = require("promisify-child-process");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = o[Symbol.iterator](); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var data_babel_rc = "\n  // {\n  //     \"presets\": [\n  //         \"@babel/preset-env\"\n  //     ]\n  // }\n  {\n  \"presets\": [\n      [\"@babel/preset-env\", {\n        \"useBuiltIns\": \"usage\", // or \"entry\" usage\n        \"corejs\": 3\n      }]\n    ]\n  }";
var data_git_ignore = ".env\n.git\nnode_modules\n";

var package_json = function package_json(parameter) {
  return "\n{\n    \"name\": \"".concat(parameter.package_name, "\",\n    \"version\": \"").concat(parameter.version, "\",\n    \"description\": \"").concat("version" in parameter ? parameter.description : "", "\",\n    \"main\": \"src/index.js\",\n    \"scripts\": {\n      \"test\": \"echo testing && exit 1\",\n      \"dev\": \"cross-env NODE_ENV=development nodemon src/index\",\n      \"build\": \"babel src -d dist\",\n      \"start\": \"cross-env NODE_ENV=production node dist/index\"\n    },\n    \"keywords\": [],\n    ").concat(parameter.git_repository != "" ? "\n        \"repository\": {\n            \"type\": \"git\",\n            \"url\": \"".concat("git_repository" in parameter ? parameter.git_repository : "\t", "\"\n          },     \n        ") : "", "\n      \"author\": \"").concat(parameter.author, "\",\n    \"license\": \"").concat(parameter.license, "\",\n    \"dependencies\": {\n      \"@babel/cli\": \"^7.10.1\",\n      \"@babel/core\": \"^7.10.2\",\n      \"@babel/preset-env\": \"^7.10.2\",\n      \"@babel/register\": \"^7.10.1\",\n      \"cors\": \"^2.8.5\",\n      \"express\": \"^4.17.1\",\n      \"cross-env\": \"^7.0.2\",\n      \"regenerator-runtime\": \"^0.13.7\",\n      \"core-js\": \"^3.8.3\"\n    },\n    \"devDependencies\": {\n      \"morgan\": \"^1.10.0\",\n      \"dotenv\": \"^8.2.0\",\n      \"nodemon\": \"^2.0.4\"\n    }\n  }\n  ");
};

console.log("\n\n  \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2557\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2557\u2588\u2588\u2588\u2557   \u2588\u2588\u2588\u2557\u2588\u2588\u2588\u2588\u2588\u2588\u2557 \u2588\u2588\u2557      \u2588\u2588\u2588\u2588\u2588\u2557 \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2557\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2557      \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2557\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2557 \u2588\u2588\u2588\u2588\u2588\u2588\u2557       \u2588\u2588\u2588\u2557   \u2588\u2588\u2557 \u2588\u2588\u2588\u2588\u2588\u2588\u2557 \u2588\u2588\u2588\u2588\u2588\u2588\u2557 \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2557\n  \u255A\u2550\u2550\u2588\u2588\u2554\u2550\u2550\u255D\u2588\u2588\u2554\u2550\u2550\u2550\u2550\u255D\u2588\u2588\u2588\u2588\u2557 \u2588\u2588\u2588\u2588\u2551\u2588\u2588\u2554\u2550\u2550\u2588\u2588\u2557\u2588\u2588\u2551     \u2588\u2588\u2554\u2550\u2550\u2588\u2588\u2557\u255A\u2550\u2550\u2588\u2588\u2554\u2550\u2550\u255D\u2588\u2588\u2554\u2550\u2550\u2550\u2550\u255D      \u2588\u2588\u2554\u2550\u2550\u2550\u2550\u255D\u2588\u2588\u2554\u2550\u2550\u2550\u2550\u255D\u2588\u2588\u2554\u2550\u2550\u2550\u2550\u255D       \u2588\u2588\u2588\u2588\u2557  \u2588\u2588\u2551\u2588\u2588\u2554\u2550\u2550\u2550\u2588\u2588\u2557\u2588\u2588\u2554\u2550\u2550\u2588\u2588\u2557\u2588\u2588\u2554\u2550\u2550\u2550\u2550\u255D\n     \u2588\u2588\u2551   \u2588\u2588\u2588\u2588\u2588\u2557  \u2588\u2588\u2554\u2588\u2588\u2588\u2588\u2554\u2588\u2588\u2551\u2588\u2588\u2588\u2588\u2588\u2588\u2554\u255D\u2588\u2588\u2551     \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2551   \u2588\u2588\u2551   \u2588\u2588\u2588\u2588\u2588\u2557  \u2588\u2588\u2588\u2588\u2588\u2557\u2588\u2588\u2588\u2588\u2588\u2557  \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2557\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2557 \u2588\u2588\u2588\u2588\u2588\u2557\u2588\u2588\u2554\u2588\u2588\u2557 \u2588\u2588\u2551\u2588\u2588\u2551   \u2588\u2588\u2551\u2588\u2588\u2551  \u2588\u2588\u2551\u2588\u2588\u2588\u2588\u2588\u2557  \n     \u2588\u2588\u2551   \u2588\u2588\u2554\u2550\u2550\u255D  \u2588\u2588\u2551\u255A\u2588\u2588\u2554\u255D\u2588\u2588\u2551\u2588\u2588\u2554\u2550\u2550\u2550\u255D \u2588\u2588\u2551     \u2588\u2588\u2554\u2550\u2550\u2588\u2588\u2551   \u2588\u2588\u2551   \u2588\u2588\u2554\u2550\u2550\u255D  \u255A\u2550\u2550\u2550\u2550\u255D\u2588\u2588\u2554\u2550\u2550\u255D  \u255A\u2550\u2550\u2550\u2550\u2588\u2588\u2551\u2588\u2588\u2554\u2550\u2550\u2550\u2588\u2588\u2557\u255A\u2550\u2550\u2550\u2550\u255D\u2588\u2588\u2551\u255A\u2588\u2588\u2557\u2588\u2588\u2551\u2588\u2588\u2551   \u2588\u2588\u2551\u2588\u2588\u2551  \u2588\u2588\u2551\u2588\u2588\u2554\u2550\u2550\u255D  \n     \u2588\u2588\u2551   \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2557\u2588\u2588\u2551 \u255A\u2550\u255D \u2588\u2588\u2551\u2588\u2588\u2551     \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2557\u2588\u2588\u2551  \u2588\u2588\u2551   \u2588\u2588\u2551   \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2557      \u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2557\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2551\u255A\u2588\u2588\u2588\u2588\u2588\u2588\u2554\u255D      \u2588\u2588\u2551 \u255A\u2588\u2588\u2588\u2588\u2551\u255A\u2588\u2588\u2588\u2588\u2588\u2588\u2554\u255D\u2588\u2588\u2588\u2588\u2588\u2588\u2554\u255D\u2588\u2588\u2588\u2588\u2588\u2588\u2588\u2557\n     \u255A\u2550\u255D   \u255A\u2550\u2550\u2550\u2550\u2550\u2550\u255D\u255A\u2550\u255D     \u255A\u2550\u255D\u255A\u2550\u255D     \u255A\u2550\u2550\u2550\u2550\u2550\u2550\u255D\u255A\u2550\u255D  \u255A\u2550\u255D   \u255A\u2550\u255D   \u255A\u2550\u2550\u2550\u2550\u2550\u2550\u255D      \u255A\u2550\u2550\u2550\u2550\u2550\u2550\u255D\u255A\u2550\u2550\u2550\u2550\u2550\u2550\u255D \u255A\u2550\u2550\u2550\u2550\u2550\u255D       \u255A\u2550\u255D  \u255A\u2550\u2550\u2550\u255D \u255A\u2550\u2550\u2550\u2550\u2550\u255D \u255A\u2550\u2550\u2550\u2550\u2550\u255D \u255A\u2550\u2550\u2550\u2550\u2550\u2550\u255D\n                                                                                                                                                                                                                                                                                                                                     \n  ");
console.log("\n\u250C\u2510 \u252C \u252C  \u250C\u2500\u2510\u252C \u252C\u250C\u2500\u2510\u250C\u2500\u2510 \u252C \u252C\u250C\u2500\u2510\u250C\u2500\u2510\u250C\u2500\u2510\u252C \u252C\u252C\u2500\u2510\u252C \u252C\u250C\u2500\u2510\n\u251C\u2534\u2510\u2514\u252C\u2518  \u2502  \u251C\u2500\u2524\u2502 \u2502\u2502\u2500\u253C\u2510\u2502 \u2502\u251C\u2524 \u2514\u2500\u2510\u251C\u2500\u2524\u2502 \u2502\u251C\u252C\u2518\u2502 \u2502\u2514\u2500\u2510\n\u2514\u2500\u2518 \u2534   \u2514\u2500\u2518\u2534 \u2534\u2514\u2500\u2518\u2514\u2500\u2518\u2514\u2514\u2500\u2518\u2514\u2500\u2518\u2514\u2500\u2518\u2534 \u2534\u2514\u2500\u2518\u2534\u2514\u2500\u2514\u2500\u2518\u2514\u2500\u2518\n  ");

_inquirer["default"].prompt([{
  type: "input",
  name: "working_dir",
  message: "¿Nombre de la carpeta a crear (Working directory)?: ",
  "default": "Carpeta_" + new Date().toLocaleString().replace(/[\s:\/]/g, "-") // default:"Carpeta_"+new Date().toLocaleString().replace(/\//g,"-")

}, {
  type: "input",
  name: "package_name",
  message: "Configurando package.json :\npackage name :",
  "default": "working_directory" //when:(entrada) => {nom_carpeta=entrada.working_dir; return true}

}, {
  type: "input",
  name: "version",
  message: "version : ",
  "default": "v1.0.0" //when:(entrada) => entrada.npm_init == 'Manual'?true:false

}, {
  type: "input",
  name: "description",
  message: "description : ",
  "default": "" //when:(entrada) => entrada.npm_init == 'Manual'?true:false

}, {
  type: "input",
  name: "git_repository",
  message: "git repository : ",
  "default": "" //when:(entrada) => entrada.npm_init == 'Manual'?true:false

}, {
  type: "input",
  name: "author",
  message: "author : ",
  "default": "" //when:(entrada) => entrada.npm_init == 'Manual'?true:false

}, {
  type: "input",
  name: "license",
  message: "Licencia : ",
  "default": "MIT" //when:(entrada) => entrada.npm_init == 'Manual'?true:false

}, {
  type: "checkbox",
  name: "archivos_primarios",
  message: "Marca que deseas generar automaticamente : ",
  choices: [".babelrc", ".env", "Dockerfile", ".gitignore", "Docker-compose.yml", //"eslint",
  "readme.md"]
}, {
  type: "list",
  name: "npm_install",
  message: "¿Deseas que se instale automaticamente las dependencias requeridas?",
  choices: ["Si", "No"]
}, {
  type: "list",
  name: "open_proyect",
  message: "Cual es el comando para importar tu proyecto en tu editor de codigo : ?",
  choices: ["code", "mate", "subl", "atom", "Ninguna de las anteriores"]
}]).then( /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(data) {
    var _package_json;

    var proccess_package_name, author, license, git_repository, version, description, package_name, _yield$exec, stdout, _iterator, _step, item;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            proccess_package_name = data.package_name, author = data.author, license = data.license, git_repository = data.git_repository, version = data.version, description = data.description;
            package_name = proccess_package_name == "default(working_dir)" ? data.working_dir : proccess_package_name;
            _context.next = 4;
            return (0, _promisifyChildProcess.exec)("mkdir ".concat(data.working_dir));

          case 4:
            _yield$exec = _context.sent;
            stdout = _yield$exec.stdout;
            _context.next = 8;
            return (0, _promisifyChildProcess.exec)("git init", {
              cwd: data.working_dir
            });

          case 8:
            _context.next = 10;
            return (0, _promisifyChildProcess.exec)("touch package.json && echo '".concat(package_json((_package_json = {
              package_name: package_name,
              author: author,
              license: license,
              git_repository: git_repository
            }, _defineProperty(_package_json, "author", author), _defineProperty(_package_json, "version", version), _defineProperty(_package_json, "description", description), _package_json)), "'>package.json"), {
              cwd: data.working_dir
            });

          case 10:
            _iterator = _createForOfIteratorHelper(data.archivos_primarios);
            _context.prev = 11;

            _iterator.s();

          case 13:
            if ((_step = _iterator.n()).done) {
              _context.next = 28;
              break;
            }

            item = _step.value;

            if (!(item == ".babelrc")) {
              _context.next = 18;
              break;
            }

            _context.next = 18;
            return (0, _promisifyChildProcess.exec)("touch ".concat(item, " && echo '").concat(data_babel_rc, "'> ").concat(item), {
              cwd: data.working_dir
            });

          case 18:
            if (!(item == ".gitignore")) {
              _context.next = 21;
              break;
            }

            _context.next = 21;
            return (0, _promisifyChildProcess.exec)("touch ".concat(item, " && echo '").concat(data_git_ignore, "'> ").concat(item), {
              cwd: data.working_dir
            });

          case 21:
            if (!(item == ".env")) {
              _context.next = 24;
              break;
            }

            _context.next = 24;
            return (0, _promisifyChildProcess.exec)("touch ".concat(item, " && echo 'handler=express'>").concat(item), {
              cwd: data.working_dir
            });

          case 24:
            _context.next = 26;
            return (0, _promisifyChildProcess.exec)("touch ".concat(item), {
              cwd: data.working_dir
            });

          case 26:
            _context.next = 13;
            break;

          case 28:
            _context.next = 33;
            break;

          case 30:
            _context.prev = 30;
            _context.t0 = _context["catch"](11);

            _iterator.e(_context.t0);

          case 33:
            _context.prev = 33;

            _iterator.f();

            return _context.finish(33);

          case 36:
            console.log("Instalando paquetes necesarias ...");
            _context.next = 39;
            return (0, _promisifyChildProcess.exec)("npm install -g degit  && degit https://github.com/choquesaurus/src.git src", {
              cwd: data.working_dir
            });

          case 39:
            if (!(data.npm_install == "Si")) {
              _context.next = 44;
              break;
            }

            console.log("Instalando dependencias necesarias ...");
            _context.next = 43;
            return (0, _promisifyChildProcess.exec)("npm install", {
              cwd: data.working_dir
            });

          case 43:
            console.log("Dependencias instaladas ... \n");

          case 44:
            console.log("Ejecutando en desarrollo (npm run dev) en una nueva terminal :D");
            _context.next = 47;
            return (0, _promisifyChildProcess.exec)("gnome-terminal -- bash -c 'npm run dev; exec zsh || exec bash'", {
              cwd: data.working_dir
            });

          case 47:
            if (!(data.open_proyect == "Ninguna de las anteriores")) {
              _context.next = 51;
              break;
            }

            console.log("Abre con tu editor favorito :D");
            _context.next = 53;
            break;

          case 51:
            _context.next = 53;
            return (0, _promisifyChildProcess.exec)("".concat(data.open_proyect, " ."), {
              cwd: data.working_dir
            });

          case 53:
            console.log("Adios :D");

          case 54:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[11, 30, 33, 36]]);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}())["catch"](function (error) {
  return console.log(error);
});